
import wx

class InputDialog(wx.Dialog):
    def __init__(self, parent, ID, title,
                 pos=wx.DefaultPosition, size=wx.DefaultSize,
                 style=wx.DEFAULT_DIALOG_STYLE, infotext="", labels=["", ""], textdefaults=["", ""], langlabel= "", langlist=[], langdefault=0):

        pre = wx.PreDialog()
        pre.Create(parent, ID, title, pos, size, style)

        self.this = pre.this
	
	sizer = wx.BoxSizer(wx.VERTICAL)

	label = wx.StaticText(self, -1, infotext)
        sizer.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)

        box = wx.BoxSizer(wx.HORIZONTAL)

	label = wx.StaticText(self, -1, langlabel)
        box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)
	
	self.lang = langlist
	# [u"Engleski", u"Srpski"]
	self.combolang = wx.ComboBox(self, -1, choices=self.lang, style=wx.CB_READONLY, size=(170, 20))
	self.combolang.Select(langdefault)      
	self.combolang.SetBackgroundColour(wx.WHITE)
	
	box.Add(self.combolang, 1, wx.ALIGN_CENTRE|wx.ALL, 5)
	
	sizer.AddSizer(box, 0, wx.GROW|wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5)	
	
        box = wx.BoxSizer(wx.HORIZONTAL)

        label = wx.StaticText(self, -1, labels[0])
        box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)

        self.text1 = wx.TextCtrl(self, -1, textdefaults[0], size=(350,-1))
        box.Add(self.text1, 1, wx.ALIGN_CENTRE|wx.ALL, 5)

        sizer.AddSizer(box, 0, wx.GROW|wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5)

        box = wx.BoxSizer(wx.HORIZONTAL)

        label = wx.StaticText(self, -1, labels[1])
        box.Add(label, 0, wx.ALIGN_CENTRE|wx.ALL, 5)

        self.text2 = wx.TextCtrl(self, -1, textdefaults[1], size=(350, -1))
        box.Add(self.text2, 1, wx.ALIGN_CENTRE|wx.ALL, 5)

        sizer.AddSizer(box, 0, wx.GROW|wx.ALIGN_CENTER_VERTICAL|wx.ALL, 5)

        line = wx.StaticLine(self, -1, size=(20,-1), style=wx.LI_HORIZONTAL)
        sizer.Add(line, 0, wx.GROW|wx.ALIGN_CENTER_VERTICAL|wx.RIGHT|wx.TOP, 5)

        box = wx.BoxSizer(wx.HORIZONTAL)

        btn = wx.Button(self, wx.ID_OK, " &Potvrdi ")
        btn.SetDefault()
        box.Add(btn, 1, wx.ALIGN_CENTRE|wx.ALL, 5)

        btn = wx.Button(self, wx.ID_CANCEL, " &Odustani ")
        box.Add(btn, 1, wx.ALIGN_CENTRE|wx.ALL, 5)

        sizer.AddSizer(box, 0, wx.ALIGN_CENTER_HORIZONTAL|wx.ALL, 5)

        self.SetSizer(sizer)
        self.SetAutoLayout(True)
        sizer.Fit(self)



