# -*- coding: UTF-8 -*-

import wx
import sys

sys.path.append("./common")

from   wrprintout2 import PrintTable
import wr

#----------------------------------------------------------------------

iconspath = "./icons/"

class ListOutput(wx.ListCtrl):
    def __init__(self, parent):
        wx.ListCtrl.__init__(self, parent, -1, style=wx.LC_REPORT|wx.LC_VIRTUAL)
                            #style=wx.LC_REPORT|wx.LC_VIRTUAL|wx.LC_HRULES|wx.LC_VRULES)

        self.InsertColumn(0, "Jezik")
        self.InsertColumn(1, u"Reč - Fraza")
        self.InsertColumn(2, "Prevod")
        self.SetColumnWidth(0, 50)
        self.SetColumnWidth(1, 200)
        self.SetColumnWidth(2, 2000)

	self.ImageList = wx.ImageList(30, 16)
        self.ImageEN = self.ImageList.Add(wx.Bitmap(iconspath + "english.xpm", wx.BITMAP_TYPE_XPM))
	self.ImageSR = self.ImageList.Add(wx.Bitmap(iconspath + "serbian.xpm", wx.BITMAP_TYPE_XPM))
	self.SetImageList(self.ImageList, wx.IMAGE_LIST_SMALL)
	
        self.SetItemCount(0)
	self.Values = []

	self.RowColorYellow = wx.ListItemAttr()
        self.RowColorYellow.SetBackgroundColour(wx.Colour(170, 220, 250))

        wx.EVT_LIST_ITEM_SELECTED(self, self.GetId(), self.OnItemSelected)
        wx.EVT_LIST_ITEM_ACTIVATED(self, self.GetId(), self.OnItemActivated)

	self.currentItem = -1
	# print self.currentItem

    def OnItemSelected(self, event):
        self.currentItem = event.m_itemIndex
	event.Skip()
	# print "Select ", self.currentItem
	# print self.Values[self.currentItem]

    def OnItemActivated(self, event):
        self.currentItem = event.m_itemIndex
        event.Skip()
	# print "Activate ", self.currentItem

    def getColumnText(self, index, col):
        item = self.GetItem(index, col)
        return item.GetText()
    
    def OnGetItemText(self, item, col):
	if len(self.Values) > 0 and col > 0:
	   return self.Values[item][col].decode("utf-8")
	else:
	   return ""

    def OnGetItemImage(self, item):
	if self.Values[item][0] == "en":
		return self.ImageEN
	elif self.Values[item][0] == "sr" :
		return self.ImageSR
	
    def OnGetItemAttr(self, item):
        if item % 2 == 1:
            return self.RowColorYellow
        else:
            return None
	
    def UpdateDialog(self, parent, mode, conn,  title="", labels=["", ""], textdefaults=["", ""], langlabel="", langlist=[], langdefault = 0):
    
        win = wr.InputDialog(parent, -1, title, wx.DefaultPosition, wx.DefaultSize,
		    	     wx.TINY_CAPTION_HORIZ, "", labels, textdefaults, langlabel, langlist, langdefault)
	win.CenterOnScreen()
	val = win.ShowModal()
	
	if val == wx.ID_OK:
	   lang = win.combolang.GetSelection()	
	   if lang == 0:
	      langtext = 'en'
	   else:
	      langtext = 'sr' 
	   
	   fraza  = win.text1.GetValue()
	   prevod = win.text2.GetValue()
	   
	   # fraza = repr(fraza)
	   # fraza = fraza.encode("utf-8")
	   # print fraza
	   
	   if mode == 1:
	      cursor = conn.cursor()
	      cursor.execute("insert into reci values(%s, %s, %s)", (langtext, fraza , prevod))
	      conn.commit()
	      
	   elif mode == 2:
	      currentdata = self.Values[self.currentItem]
	      cursor = conn.cursor()
	      cursor.execute("update reci set jezik=%s, fraza=%s, prevod=%s  where jezik=%s and fraza=%s and prevod=%s",
	                    (langtext, fraza, prevod, currentdata[0], currentdata[1], currentdata[2]))     
	      conn.commit()
	      
    
    def ItemAdd(self, event, parent, conn):
    
	# print "dodaj", self.currentItem
	
	self.UpdateDialog(parent, 1, conn, u"Dodaj novu reč-frazu", 
	                        [u"Reč - Fraza : ", "       Prevod : "],
	  			["", ""], 
				"          Jezik : ", [u"Engleski", u"Srpski"], 1)			   
	
    def ItemDel(self, event, parent, conn):
	if self.currentItem != -1:
	    dlg = wx.MessageDialog(parent, 'Da li ste sigurni?', 'Brisanje podatka', wx.YES_NO | wx.NO_DEFAULT | wx.ICON_WARNING) 
    
	    if dlg.ShowModal() == wx.ID_YES: 
		dlg.Destroy() 
		# print self.Values[self.currentItem]
		cursor = conn.cursor()
		data = self.Values[self.currentItem] 
		cursor.execute("delete from reci where jezik=%s and fraza=%s and prevod=%s", (data[0], data[1], data[2])) 
		conn.commit()
	    else: 
		dlg.Destroy() 
    
	    	
    def ItemEdit(self, event, parent, conn):
	if self.currentItem != -1:
	    data = self.Values[self.currentItem]
	    if data[0] == 'en':
		lang = 0
	    else:
		lang = 1
		    
	    self.UpdateDialog(parent, 2, conn, u"Izmeni reč-frazu", 
	                        [u"Reč - Fraza : ", "       Prevod : "],
	  			[data[1].decode("utf-8"), data[2].decode("utf-8")],
				"          Jezik : ", [u"Engleski", u"Srpski"], lang)			   		
    
	# print "izmeni", self.currentItem

    def ItemsPrint(self, event, parent):
    	# print "print", self.currentItem, self.GetItemCount()
	prt = PrintTable(parent)
        prt.label = [u"Jezik", u"Reč - Fraza", u"Prevod"]
        prt.set_column = [0.5, 1.5, 4.8]
	prt.set_column = []
        prt.data = self.Values
	# prt.SetColumnSize(0, 50)
	prt.SetHeader("wxRecnik list output")
        # prt.SetFooter("Stampano : ", type = "Date & Time", align=wx.ALIGN_CENTER, indent = -2, colour = wx.RED)
	# prt.SetFooter("Strana broj : ", type ="Num")
	prt.SetFooter()
	# prt.SetZoom(100)
        prt.Preview()


