#!/usr/bin/env python
# -*- coding: utf-8 -*-

import wx 	# main wx module

from wx.lib.dialogs import * 

import sys
import sqlite

sys.path.append("./common")

import wr 	# wxRecnik name space module

iconspath = "./icons/"

ID_FIND  = 100

ID_PRINT = 200

ID_ADD   = 300
ID_DEL   = 301
ID_EDIT  = 302

ID_ABOUT = 400
ID_HELP  = 401

ID_INSTALL    = 500
ID_README     = 501
ID_TODO       = 502
ID_CHANGELOG  = 503

ID_EXIT  = 3000

class wxYuRecnik(wx.Frame):
    def __init__(self, parent, id, title):
        wx.Frame.__init__(self, parent, -4, title,  
	                        style=wx.DEFAULT_FRAME_STYLE|wx.NO_FULL_REPAINT_ON_RESIZE, size=(600, 400))
		
	    		
	self.conn = sqlite.connect("reci.db", encoding="utf-8")
	
	wx.EVT_CLOSE(self, self.OnExit)		
	
	self.sb = wr.CreateStatusBar(self)
	
	tb = self.CreateToolBar(wx.TB_HORIZONTAL)
	tb.SetToolBitmapSize((16 ,16))		 
	
	icoFind   = wx.Bitmap(iconspath + "find.xpm", wx.BITMAP_TYPE_XPM)
	
	icoPrint  = wx.Bitmap(iconspath + "print.xpm", wx.BITMAP_TYPE_XPM)
	
	icoAdd  = wx.Bitmap(iconspath + "plus.xpm", wx.BITMAP_TYPE_XPM)
	icoDel  = wx.Bitmap(iconspath + "minus.xpm", wx.BITMAP_TYPE_XPM)
	icoEdit = wx.Bitmap(iconspath + "edit.xpm", wx.BITMAP_TYPE_XPM)
	
	icoAbout  = wx.Bitmap(iconspath + "about.xpm", wx.BITMAP_TYPE_XPM)
	icoHelp = wx.Bitmap(iconspath + "help.xpm", wx.BITMAP_TYPE_XPM)
	
	icoExit   = wx.Bitmap(iconspath + "exit.xpm", wx.BITMAP_TYPE_XPM)
		
	tb.AddSimpleTool(ID_FIND, icoFind, u"Traži", u"Traži reč")
	wx.EVT_TOOL(tb, ID_FIND, self.OnComboFind)
	
	tb.AddSeparator()
	
	tb.AddSimpleTool(ID_PRINT, icoPrint, u"Štampaj", u"Štampaj rezltat traženja")
	wx.EVT_TOOL(tb, ID_PRINT, self.OnOutList)
	
	tb.AddSeparator()
		
	tb.AddSimpleTool(ID_ADD, icoAdd, "Dodaj", u"Dodaj novu reč")
	wx.EVT_TOOL(tb, ID_ADD, self.OnOutList)
	
	tb.AddSimpleTool(ID_DEL, icoDel, u"Obriši", u"Obriši izabranu reč")
	wx.EVT_TOOL(tb, ID_DEL, self.OnOutList)
	
	tb.AddSimpleTool(ID_EDIT, icoEdit, "Izmeni", u"Izmeni izabranu reč")
	wx.EVT_TOOL(tb, ID_EDIT, self.OnOutList)
	
	tb.AddSeparator()
			
	tb.AddSimpleTool(ID_HELP, icoHelp, "Uputstvo", u"Korisničko uputstvo")
	wx.EVT_TOOL(tb, ID_HELP, self.OnHelp)
	
	tb.AddSimpleTool(ID_ABOUT, icoAbout, "O programu", "Program info")
	wx.EVT_TOOL(tb, ID_ABOUT, self.OnAbout)
	
	tb.AddSeparator()
	
	tb.AddSimpleTool(ID_EXIT, icoExit, "Izlaz", "Izlaz iz programa")
	wx.EVT_TOOL(tb, ID_EXIT, self.OnExit)
			
	tb.Realize()
		
        filemenu = wx.Menu()
        filemenu.Append(ID_EXIT,"I&zlaz\tCtrl+Z","Kraj rada sa programom")
        
	help = wx.Menu()
	help.Append(ID_ABOUT, u"&O programu ...\tAlt+I", u"Informacije o wxRečniku")
	help.AppendSeparator()
	help.Append(ID_HELP, u"&Uputstvo\tAlt+H", u"Uputstvo za korišćenje programa")
	help.AppendSeparator()
	help.Append(ID_README,   u"Obavezno &pročitaj\tAlt+O", u"Obavezno pročitati")
	help.Append(ID_INSTALL,  u"&Instalacija", "Uputstvo za instalaciju programa")
	help.Append(ID_TODO,     u"&Uraditi...", u"Šta će se jos uraditi na programu")
	help.Append(ID_CHANGELOG,u"&Lista izmena\tAlt+L", u"Lista izmena na programu")	
	
        menuBar = wx.MenuBar()
	menuBar.Append(filemenu,"&Datoteka")  
	menuBar.Append(help, u"&Pomo\u0107")  
	
        self.SetMenuBar(menuBar)  # Adding the MenuBar to the Frame content. 
	
	wx.EVT_MENU(self, ID_ABOUT, self.OnAbout)
	wx.EVT_MENU(self, ID_HELP, self.OnHelp)
        wx.EVT_MENU(self, ID_EXIT, self.OnExit)
	
	wx.EVT_MENU(self, ID_README, self.OnDevelopInfo)
	wx.EVT_MENU(self, ID_INSTALL, self.OnDevelopInfo)	
	wx.EVT_MENU(self, ID_TODO, self.OnDevelopInfo)	
	wx.EVT_MENU(self, ID_CHANGELOG, self.OnDevelopInfo)	
	
	self.SizerMain    = wx.BoxSizer(wx.VERTICAL)
	
	self.PanelTop = wx.Panel(self, -1, size = (600, 60), style=wx.RAISED_BORDER|wx.SUNKEN_BORDER)
	self.PanelTop.SetBackgroundColour(wx.Colour(80, 200, 250))
	
	self.SizerTop = wx.BoxSizer(wx.HORIZONTAL)
	
	self.StaticBoxNacin = wx.StaticBox(self.PanelTop, -1, "Vrsta pretrage")
	
	self.GroupNacin = wx.StaticBoxSizer(self.StaticBoxNacin, wx.HORIZONTAL)
	
	self.NacinTrazenja = [u"Reč koja počinje sa", u"Reč koja sadrži", u"Reč koja se završava sa", u"Tražena reč"]
	self.ComboBoxNacinTrazenja = wx.ComboBox(self.PanelTop, -1, choices=self.NacinTrazenja, style=wx.CB_READONLY, size=(170, 40))
	self.ComboBoxNacinTrazenja.Select(0)      
	self.ComboBoxNacinTrazenja.SetBackgroundColour(wx.WHITE)
	
	self.GroupNacin.Add(self.ComboBoxNacinTrazenja, 1, wx.ALIGN_CENTRE|wx.ALL)		
	
	self.StaticBoxTrazi = wx.StaticBox(self.PanelTop, -1, u"Tražena reč")
	self.GroupTrazi     = wx.StaticBoxSizer(self.StaticBoxTrazi, wx.HORIZONTAL)
	
	self.ListaTrazenja = []
	
	self.ComboBoxListaTrazenja = wx.ComboBox(self.PanelTop, ID_FIND, choices=self.ListaTrazenja, size=(170, 40)) 
	self.ComboBoxListaTrazenja.SetBackgroundColour(wx.WHITE)
				
	self.GroupTrazi.Add(self.ComboBoxListaTrazenja, 1, wx.ALIGN_CENTRE|wx.ALL)
	
	self.SizerTop.Add(self.GroupNacin, 0, wx.EXPAND)
	self.SizerTop.Add(self.GroupTrazi, 1, wx.EXPAND)
		
	self.PanelTop.SetSizer(self.SizerTop)
	self.PanelTop.Layout()
	
	wx.EVT_COMBOBOX(self, ID_FIND, self.OnComboFind)
	wx.EVT_TEXT_ENTER(self, ID_FIND, self.OnComboFind)
	
	self.PanelBottom= wx.Panel(self, -1, size = (600, 200), style=wx.RAISED_BORDER|wx.SUNKEN_BORDER)
	
	self.SizerList = wx.BoxSizer(wx.VERTICAL)
	self.outlist = wr.ListOutput(self.PanelBottom)
	self.SizerList.Add(self.outlist, 1, wx.EXPAND)
	self.PanelBottom.SetSizer(self.SizerList)
	self.PanelBottom.Layout()                 
	
	
	self.SizerMain.Add(self.PanelTop, 0, wx.EXPAND)
	self.SizerMain.Add((0, 2), 0, wx.EXPAND)
	self.SizerMain.Add(self.PanelBottom, 1, wx.EXPAND)
	
	self.SizerMain.Fit(self)
	self.SetAutoLayout(True)
	self.SetSizer(self.SizerMain)
	
	self.Layout()
	
    def OnExit(self, event):
	self.sb.timer.Stop()
        del self.sb.timer
	self.conn.close()
	wr.Exit(self)
	
    def OnAbout(self, event):
	wr.AboutBox(self, "Info", u"wxRečnik " + wr.Version)

    def OnHelp(self, event):
	readme = open("HELP.txt", "r")
	text = readme.read().decode("utf-8")
	dlg = ScrolledMessageDialog(self, text, 'wxRecnik Help')
	readme.close()
        dlg.ShowModal()
        dlg.Destroy()
	
    def OnDevelopInfo(self, event):
	info = event.GetId()
	
	if info == ID_INSTALL:
	    infodat = "INSTALL.txt"	
	elif info == ID_README     :
	    infodat = "README.txt"	
	elif info == ID_TODO       :
	    infodat = "TODO.txt"		
	elif info == ID_CHANGELOG  :
	    infodat = "Changelog.txt"	
		
	readme = open(infodat, "r")
	text = readme.read().decode("utf-8")
	# text = text.encode("utf-8")
	dlg = ScrolledMessageDialog(self, text, 'Dodatni info : ' + infodat)
	readme.close()
        dlg.ShowModal()
        dlg.Destroy()
	
    def OnOutList(self, event):
	info = event.GetId()
	
	if info == ID_PRINT:
	    self.outlist.ItemsPrint(self, self)	
	elif info == ID_ADD:
	    self.outlist.ItemAdd(self, self, self.conn)	
	elif info == ID_DEL:
	    self.outlist.ItemDel(self, self, self.conn)	
	    self.OnComboFind(event)
	elif info == ID_EDIT:
	    self.outlist.ItemEdit(self, self, self.conn)
	    self.OnComboFind(event)	
		
    def OnComboFind(self, event):

	self.outlist.Values = []
	self.outlist.SetItemCount(0)
	self.outlist.currentItem = -1 
	
	# FindText =  event.GetString()
	
	FindText = self.ComboBoxListaTrazenja.GetValue()
	
	if FindText == "":
	    return
	
	FindText = FindText.encode("utf-8")
		
	if self.ComboBoxListaTrazenja.FindString(FindText) == -1:
	    self.ComboBoxListaTrazenja.Append(FindText)
	
	FindType = self.ComboBoxNacinTrazenja.GetSelection()	
	
	if FindType == 0:
	    FindText = FindText + "%"
	    
	elif FindType == 1:
	     FindText = "%" + FindText + "%"
	     
	elif FindType == 2:
	     FindText = "%" + FindText
	     
	else :
	     FindText = FindText     
	
	# self.conn = sqlite.connect("reci.db")
	cursor = self.conn.cursor()

	sqlfind = "select * from reci where fraza like %s"

	cursor.execute(sqlfind, (FindText))

	results = cursor.fetchall()
	
	self.outlist.Values = results
	self.outlist.SetItemCount(len(results))
	self.outlist.currentItem = -1
	
	self.sb.SetStatusText("Pronadjeno fraza : %d" % len(results), 0)	
		
    	# conn.close()

	
class YuRecnikApp(wx.App):
    def OnInit(self):
	wx.InitAllImageHandlers()
	try:	
	    open("reci.db")    
	except:
	    wx.MessageBox("Ne postoji baza reči <reci.db>", "Greška !!!", wx.OK|wx.CENTRE)
	    sys.exit(-1)
	splash = wr.SplashScreen() # splash screen and start main frame
	splash.Show()
	
	return True

if __name__ == "__main__":
    app = YuRecnikApp(0)
    app.MainLoop()


